Subject: Re: [PATCH] of: fix recursive locking in of_get_next_available_child()

From: Grant Likely <[email-masked]>
Date: Mon, 11 Feb 2013 22:39:07 +0000

On Mon, 11 Feb 2013 14:15:32 -0700, Stephen Warren <[email-masked]> wrote:
> From: Stephen Warren <[email-masked]>
> 
> of_get_next_available_child() acquires devtree_lock, then calls
> of_device_is_available() which calls of_get_property() which calls
> of_find_property() which tries to re-acquire devtree_lock, thus causing
> deadlock.
> 
> To avoid this, create a new __of_device_is_available() which calls
> __of_get_property() instead, which calls __of_find_property(), which
> does not take the lock,. Update of_get_next_available_child() to call
> the new __of_device_is_available() since it already owns the lock.
> 
> Signed-off-by: Stephen Warren <[email-masked]>

Thanks for looking at this Stephen. I ended up applying my version of
this patch though just because it was more convenient to do so. It was
pretty much identical anyway.

g.